/*
 * JBoss, Home of Professional Open Source.
 * See the COPYRIGHT.txt file distributed with this work for information
 * regarding copyright ownership.  Some portions may be licensed
 * to Red Hat, Inc. under one or more contributor license agreements.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 */
package org.teiid.byteman;

import org.teiid.translator.jdbc.TranslatedCommand;
import org.teiid.translator.ExecutionContext;
import org.teiid.language.*;

import org.teiid.core.util.StringUtil;

import java.util.*;

import org.jboss.byteman.rule.Rule;  
import org.jboss.byteman.rule.helper.Helper;  


public class BytemanHelperForTranslator extends Helper {  
    
    protected BytemanHelperForTranslator(Rule rule) {  
        super(rule);  
    }  
    
    public void printToString(Object obj) {  
        debug("vvvvvvvvvvvvvvvvvvvvvvvvvvv"); 
        debug(String.format( "\nToString %s: %s", obj.getClass().getName(), obj.toString()));
        debug("^^^^^^^^^^^^^^^^^^^^^^^^^^^");  
    }   
    
    public void printCount(Object obj) {  
        debug("vvvvvvvvvvvvvvvvvvvvvvvvvvv"); 
        
        if (obj == null) {
            debug(String.format( "\nCount %s: %s", obj.getClass().getName(), "is null"));
            
        } else if (obj.getClass().isArray()) {
            Object[] objList = (Object[]) obj;
			debug(String.format( "\nCount %s: %s", obj.getClass().getName(), objList.length));
            
		} else if (obj instanceof Collection) {
                Collection c = (Collection) obj;
                debug(String.format( "\nCount %s: %s", obj.getClass().getName(), c.size()));
            
		} else	if (obj instanceof Map) {
            Map m = (Map) obj;
            debug(String.format( "\nCount %s: %s", obj.getClass().getName(), m.size()));
		} else {
            debug(String.format( "\nCount for class is not supported %s", obj.getClass().getName()));
        }
        
        debug("^^^^^^^^^^^^^^^^^^^^^^^^^^^");  
    }       
    
    public void printPayLoad(Object obj) {  
        ExecutionContext executionContext = (ExecutionContext) obj;  
        
        StringBuilder builder = new StringBuilder();
        
        Object payload = executionContext.getExecutionPayload();
        if (payload != null) {
            builder.append(String.format( "\nPayload %s: %s", payload.getClass().getName(), payload.toString()));

        } else {
            builder.append("No Payload");
        }
        debug("vvvvvvvvvvvvvvvvvvvvvvvvvvv");  
        debug(builder.toString());
        debug("^^^^^^^^^^^^^^^^^^^^^^^^^^^");  
    }  
    
    
    
    
    
}  


